/* 
 * File:   AfficheurOLED.h
 * Author: pcruchet
 *
 * Created on 6 mai 2025, 15:32
 */

#ifndef AFFICHEUR_OLED_H
#define AFFICHEUR_OLED_H

#include <SSD1306.h>
#include <Wire.h>

/**
 * @brief Classe d'affichage OLED personnalisée avec support dynamique des polices
 */
class AfficheurOLED : public SSD1306 {
public:
    AfficheurOLED(uint8_t adresseI2C, uint8_t pinSDA, uint8_t pinSCL);

    void begin();
    void setPolice(const uint8_t* police); // Change la police et ajuste la hauteur
    void afficher(const String& texte, int ligne);
    void effacer();
    void effacer(int ligne);

private:
    int hauteurLigne;
};

#endif
