/** 
 * @File   BddException.h
 * @Author pcruchet
 *
 * @Created on 24 avril 2025, 10:06
 */

#ifndef BDDEXCEPTION_H
#define BDDEXCEPTION_H

#include <Arduino.h>
#include <stdexcept>

/**
 * @class BddException
 * @brief Exception personnalisée pour les erreurs liées à la base de données SQLite.
 *
 * Cette classe hérite de std::runtime_error et permet de lever des erreurs avec un message explicite.
 */
class BddException : public std::runtime_error {
public:
    /**
     * @brief Constructeur de l'exception.
     * @param message Message d'erreur à afficher.
     */
    explicit BddException(const String& message) : std::runtime_error(message.c_str()) {}
};


#endif /* BDDEXCEPTION_H */

