/* 
 * File:   Vanne.cpp
 * Author: pcruchet
 * 
 * Created on 29 avril 2025, 11:56
 */

#include "Vanne.h"

Vanne::Vanne(uint8_t _brocheSelection, uint8_t _inA, uint8_t _inB, uint16_t _dureeImpulsionMs)
    : brocheSelection(_brocheSelection), inA(_inA), inB(_inB), dureeImpulsion(_dureeImpulsionMs) {}

void Vanne::begin() {
    pinMode(brocheSelection, OUTPUT);
    pinMode(inA, OUTPUT);
    pinMode(inB, OUTPUT);
    deselectionner();
    arreter();
}

void Vanne::selectionner() {
    digitalWrite(brocheSelection, HIGH);
}

void Vanne::deselectionner() {
    digitalWrite(brocheSelection, LOW);
}

void Vanne::arreter() {
    digitalWrite(inA, LOW);
    digitalWrite(inB, LOW);
}

void Vanne::setDureeImpulsion(uint16_t _dureeMs) {
    dureeImpulsion = _dureeMs;
}

void Vanne::ouvrir() {
    selectionner();
    digitalWrite(inA, HIGH);
    digitalWrite(inB, LOW);
    delay(dureeImpulsion);
    arreter();
    deselectionner();
}

void Vanne::fermer() {
    selectionner();
    digitalWrite(inA, LOW);
    digitalWrite(inB, HIGH);
    delay(dureeImpulsion);
    arreter();
    deselectionner();
}
