/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/cppFiles/main.cc to edit this template
 */

/* 
 * File:   main.cpp
 * Author: pcruchet
 *
 * Created on 29 avril 2025, 12:00
 */

#include <Arduino.h>
#include "Vanne.h"
#include "AfficheurOLED.h"
#include "AccesBdd.h"

// Pilotage 1 vanne

//Vanne *vanne1;
//
//const int PIN_BOUTON = 36; // BP1 sur GPIO36
//const int PIN_LED = 23; // LED sur GPIO23
//
//bool etatLed = true;
//bool boutonPrecedent = false;
//
//void setup()
//{
//    Serial.begin(115200);
//    delay(1000);
//    vanne1 = new Vanne(05,02,15);
//    vanne1->begin();
//
//    pinMode(PIN_BOUTON, INPUT); // Entrée sans pull-up interne sur GPIO36
//    pinMode(PIN_LED, OUTPUT);
//    digitalWrite(PIN_LED, LOW);
//
//}
//
//void loop()
//{
//    bool boutonActuel = digitalRead(PIN_BOUTON);
//
//    // Détection d'un front montant (passage de NON appuyé à appuyé)
//    if (boutonActuel && !boutonPrecedent)
//    {
//        etatLed = !etatLed; // Inverser l'état de la LED
//        digitalWrite(PIN_LED, etatLed ? HIGH : LOW);
//        if(etatLed)
//            vanne1->ouvrir();
//        else
//            vanne1->fermer();
//    }
//
//    boutonPrecedent = boutonActuel;
//
//    delay(50); // Antirebond logiciel (50 ms)
//}

// -------------------------------------------------

// Pilotage 4 vannes

const int PIN_LED = 23; // LED unique


const int NB_BOUTONS = 4;
const int brochesBoutons[NB_BOUTONS] = {36, 39, 34, 35}; // BP1 à BP4
bool etatsBoutonsPrec[NB_BOUTONS] = {false, false, false, false};


Vanne* vannes[NB_BOUTONS]; // Pointeurs vers objets vanne
const int brochesVannes[NB_BOUTONS] = {05, 17, 16, 04}; // EV1 à EV4
const int INA = 2;
const int INB = 15;
bool etatsVannes[NB_BOUTONS];

AfficheurOLED* afficheur;

void setup()
{
    afficheur = new AfficheurOLED(0x3C,21,22);
    afficheur->begin();
    
    for (int i = 0; i < NB_BOUTONS; i++)
    {
        vannes[i] = new Vanne(brochesVannes[i], INA, INB, 500);
        vannes[i]->begin();
        etatsVannes[i] = false;
        afficheur->effacer(i + 1); // ligne 1 à 4
        afficheur->afficher("Ev" + String(i + 1) + " - fermée", i);
        pinMode(brochesBoutons[i], INPUT); // ou INPUT_PULLUP selon ton câblage
    }
    
     
}

void loop()
{
    int nombreAppuis = 0;
    int indexAppui = -1;
    bool etatsBoutonsActuels[NB_BOUTONS];

    // Lecture des boutons
    for (int i = 0; i < NB_BOUTONS; i++)
    {
        etatsBoutonsActuels[i] = digitalRead(brochesBoutons[i]) == HIGH;
        if (etatsBoutonsActuels[i] && !etatsBoutonsPrec[i])
        {
            nombreAppuis++;
            indexAppui = i;
        }
    }

    if (nombreAppuis == 1)
    {
        if (etatsVannes[indexAppui])
        {
            vannes[indexAppui]->fermer();
            etatsVannes[indexAppui] = false;
            afficheur->effacer(indexAppui + 1);
            afficheur->afficher("Ev" + String(indexAppui + 1) + " - fermée", indexAppui);
        }
        else
        {
            vannes[indexAppui]->ouvrir();
            etatsVannes[indexAppui] = true;
            afficheur->effacer(indexAppui + 1);
            afficheur->afficher("Ev" + String(indexAppui + 1) + " - ouverte", indexAppui);
        }
    }

    // Mise à jour des états précédents
    for (int i = 0; i < NB_BOUTONS; i++)
    {
        etatsBoutonsPrec[i] = etatsBoutonsActuels[i];
    }

    delay(50); // Antirebond logiciel
}

